-------------------------------------------------------------------------------------
-- | Namespace Definitions |---------------------------------------------------------
-------------------------------------------------------------------------------------

-- Retrieve the addon name and the namespace table.
local addon, npcg = ...

local functua   = npcg.functua
local stringLib = npcg.functua.string
local util      = npcg.functua.util

function npcGenerator_settings_Frame_Input_MockZone_OnShow(self)
	self:SetText(util.eitherOr(not stringLib.nilOrWhitespace(NPCG_Options.locationSettings.mockZone), NPCG_Options.locationSettings.mockZone, self.defaultText))
	self.Refresh()
end

function npcGenerator_settings_Frame_Input_MockSubZone_OnShow(self)
	self:SetText(util.eitherOr(not stringLib.nilOrWhitespace(NPCG_Options.locationSettings.mockSubZone), NPCG_Options.locationSettings.mockSubZone, self.defaultText))
	self.Refresh()
end

function npcGenerator_settings_Frame_Input_FriendChance_OnShow(self)
	self:SetText(util.eitherOr(not stringLib.nilOrWhitespace(NPCG_Options.friendSettings.chance), NPCG_Options.friendSettings.chance, 0.1))
	self.Refresh()
end

function npcGenerator_settings_Frame_Input_FriendChance_OnEditFocusLost(self)
	if tonumber(self:GetText()) and tonumber(self:GetText()) <= 1.0 and tonumber(self:GetText()) >= 0.0 then
		NPCG_Options.friendSettings.chance = tonumber(self:GetText())
	else
		self:SetText(NPCG_Options.friendSettings.chance)
	end
end
