-------------------------------------------------------------------------------------
-- | Namespace Definitions |---------------------------------------------------------
-------------------------------------------------------------------------------------

-- Retrieve the addon name and the namespace table.
local addon, npcg = ...

-- Import Modules.
local data      = npcg.data.race
local trait     = npcg.generators.trait

-- Set up Modules.
local generator = { }

-- Make Modules public in npcg.
npcg.generators.race2 = generator

-------------------------------------------------------------------------------------
-- | Generator | --------------------------------------------------------------------
-------------------------------------------------------------------------------------

-- Default generator.
generator.generateRandomTrait = function() return "Error: generateRandomTrait is not set" end

-------------------------------------------------------------------------------------
-- | Initialization | ---------------------------------------------------------------
-------------------------------------------------------------------------------------

-- initialize :: ()
-- Initializes the generator, supplying it with arguments such as options and data tables.
-- Function is impure w.r.t. generator.generateRandomTrait.
function generator.initialize()
  generator.generateRandomTrait = trait.createTraitGenerator(
    data.defaultTable,
    data.zoneDataTable,
    data.subZoneDataTable,
    trait.generatorFunctions.getDefaultGeneratorFunction(),
    trait.filterFunctions.getDefaultFilterFunction(),
    trait.selectorFunctions.selectUsingWeightedRandom)
end

-- End of File.